-------------------------------------------------------------------------------
-- Second VHDL file: simple 8-bit adder
-- Uses items from "my_package" created in WORK library directory
-- in your current project directory
-- Save it as bit8_adder.vhd

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.my_package.all;

entity bit8_adder is
  port(
    a, b: in std_logic_vector(7 downto 0);
    ci: in std_logic;
    y: out std_logic_vector(7 downto 0);
    co: out std_logic);
end bit8_adder;


architecture structural of bit8_adder is
  signal sum1, sum2: std_logic_vector(4 downto 0);

begin
  sum1 <= add4_func(a(3 downto 0), b(3 downto 0), ci);
  sum2 <= add4_func(a(7 downto 4), b(7 downto 4), sum1(4));
  y <= sum2(3 downto 0) & sum1(3 downto 0);
  co <= sum2(4);
end;
-------------------------------------------------------------------------------
