-------------------------------------------------------------------------------
-- First VHDL file: has package declaration and package body.
-- Save it as my_package.vhd

library IEEE;
use IEEE.std_logic_1164.all;

-------------------------------------------------------------------------------
package my_package is

function add4_func(a, b : std_logic_vector(3 downto 0); carry : std_logic)
  return std_logic_vector;
  
procedure add4_proc
  (a, b : in std_logic_vector(3 downto 0);
  carry: in std_logic;
  signal sum: out std_logic_vector(3 downto 0);
  signal cout: out std_logic);
  
end package my_package;

-------------------------------------------------------------------------------
package body my_package is
-- functions, procedures, etc. descriptions

function add4_func (
  a, b : std_logic_vector(3 downto 0); 
  carry: std_logic)
  return std_logic_vector is
  
  variable cout: std_logic;
  variable cin: std_logic;
  variable sum: std_logic_vector(4 downto 0);
  
begin
  cin := carry;
  sum := "00000";
  loop1: for i in 0 to 3 loop
    cout := (a(i) and b(i)) or (a(i) and cin) or (b(i) and cin);
    sum(i) := a(i) xor b(i) xor cin;
    cin := cout;
  end loop loop1;
  sum(4) := cout;
  return sum;
end add4_func;


procedure add4_proc (
  a, b : in std_logic_vector(3 downto 0);
  carry: in std_logic;
  signal sum: out std_logic_vector(3 downto 0);
  signal cout: out std_logic) is
  
  variable c: std_logic;
  
begin
  c := carry;
  for i in 0 to 3 loop
    sum(i) <= a(i) xor b(i) xor c;
    c := (a(i) and b(i)) or (a(i) and c) or (b(i) and c);
  end loop;
  cout <= c;
end add4_proc;


end package body my_package;
-------------------------------------------------------------------------------
