-------------------------------------------------------------------------------
-- Second VHDL file: simple 4-bit adder
-- Uses items from "my_package" created in WORK library directory
-- in your current project directory
-- Save it as bit4_adder.vhd

library IEEE;
use IEEE.std_logic_1164.all;
use WORK.my_package.all;

entity bit4_adder is
  port(
    a, b: in std_logic_vector(3 downto 0); -- use Slide Switches on DE1-SoC board to input a,b each on four bits
    ci: in std_logic; -- use last Slide Switch to input ci
    y: out std_logic_vector(3 downto 0); -- drive the first four REd LEDs on the board
    co: out std_logic); -- use last Red LED to show carry output
end bit4_adder;


architecture structural of bit4_adder is
  signal sum1, sum2: std_logic_vector(2 downto 0);

begin
  sum1 <= add2_func(a(1 downto 0), b(1 downto 0), ci);
  sum2 <= add2_func(a(3 downto 2), b(3 downto 2), sum1(2));
  y <= sum2(1 downto 0) & sum1(1 downto 0);
  co <= sum2(2);
end;
-------------------------------------------------------------------------------
